/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 67 "gram.y" /* yacc.c:339  */

#include <stdio.h>
#include <ctype.h>
#include "twm.h"
#include "menus.h"
#include "list.h"
#include "util.h"
#include "screen.h"
#include "parse.h"
#include "add_window.h"
#include <X11/Xos.h>
#include <X11/Xmu/CharSet.h>

static char *Action = "";
static char *Name = "";
static MenuRoot	*root, *pull = NULL;

static MenuRoot *GetRoot ( const char *name, const char *fore, const char *back );
static void GotButton ( int butt, int func );
static void GotKey ( char *key, int func );
static void GotTitleButton ( char *bitmapname, int func, Bool rightside );
static Bool CheckWarpScreenArg ( char *s );
static Bool CheckWarpRingArg ( char *s );
static Bool CheckColormapArg ( char *s );
static void RemoveDQuote ( char *str );

static char *ptr;
static name_list **list;
static int cont = 0;
static int color;
int mods = 0;
unsigned int mods_used = (ShiftMask | ControlMask | Mod1Mask);

extern int yylineno;
static void yyerror ( const char *s );


#line 104 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_GRAM_H_INCLUDED
# define YY_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    LB = 258,
    RB = 259,
    LP = 260,
    RP = 261,
    MENUS = 262,
    MENU = 263,
    BUTTON = 264,
    DEFAULT_FUNCTION = 265,
    PLUS = 266,
    MINUS = 267,
    ALL = 268,
    OR = 269,
    CURSORS = 270,
    ICONS = 271,
    COLOR = 272,
    SAVECOLOR = 273,
    MONOCHROME = 274,
    FUNCTION = 275,
    WINDOW_FUNCTION = 276,
    MAKE_TITLE = 277,
    GRAYSCALE = 278,
    NO_TITLE = 279,
    AUTO_RAISE = 280,
    META = 281,
    SHIFT = 282,
    LOCK = 283,
    CONTROL = 284,
    WINDOW = 285,
    TITLE = 286,
    ICON = 287,
    ROOT = 288,
    FRAME = 289,
    COLON = 290,
    EQUALS = 291,
    START_ICONIFIED = 292,
    MOVE = 293,
    RESIZE = 294,
    WAIT = 295,
    SELECT = 296,
    KILL = 297,
    LEFT_TITLEBUTTON = 298,
    RIGHT_TITLEBUTTON = 299,
    NUMBER = 300,
    KEYWORD = 301,
    NKEYWORD = 302,
    CKEYWORD = 303,
    CLKEYWORD = 304,
    FKEYWORD = 305,
    FSKEYWORD = 306,
    SKEYWORD = 307,
    DKEYWORD = 308,
    JKEYWORD = 309,
    WINDOW_RING = 310,
    WARP_CURSOR = 311,
    ERRORTOKEN = 312,
    NO_STACKMODE = 313,
    STRING = 314
  };
#endif
/* Tokens.  */
#define LB 258
#define RB 259
#define LP 260
#define RP 261
#define MENUS 262
#define MENU 263
#define BUTTON 264
#define DEFAULT_FUNCTION 265
#define PLUS 266
#define MINUS 267
#define ALL 268
#define OR 269
#define CURSORS 270
#define ICONS 271
#define COLOR 272
#define SAVECOLOR 273
#define MONOCHROME 274
#define FUNCTION 275
#define WINDOW_FUNCTION 276
#define MAKE_TITLE 277
#define GRAYSCALE 278
#define NO_TITLE 279
#define AUTO_RAISE 280
#define META 281
#define SHIFT 282
#define LOCK 283
#define CONTROL 284
#define WINDOW 285
#define TITLE 286
#define ICON 287
#define ROOT 288
#define FRAME 289
#define COLON 290
#define EQUALS 291
#define START_ICONIFIED 292
#define MOVE 293
#define RESIZE 294
#define WAIT 295
#define SELECT 296
#define KILL 297
#define LEFT_TITLEBUTTON 298
#define RIGHT_TITLEBUTTON 299
#define NUMBER 300
#define KEYWORD 301
#define NKEYWORD 302
#define CKEYWORD 303
#define CLKEYWORD 304
#define FKEYWORD 305
#define FSKEYWORD 306
#define SKEYWORD 307
#define DKEYWORD 308
#define JKEYWORD 309
#define WINDOW_RING 310
#define WARP_CURSOR 311
#define ERRORTOKEN 312
#define NO_STACKMODE 313
#define STRING 314

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 106 "gram.y" /* yacc.c:355  */

    int num;
    char *ptr;

#line 267 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 284 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   202

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  60
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  58
/* YYNRULES -- Number of rules.  */
#define YYNRULES  142
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  211

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   314

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   133,   133,   136,   137,   140,   141,   142,   143,   144,
     145,   148,   151,   155,   171,   172,   173,   173,   175,   177,
     177,   179,   181,   181,   183,   183,   185,   185,   187,   187,
     190,   190,   192,   192,   194,   194,   196,   196,   198,   198,
     200,   202,   202,   204,   220,   228,   228,   230,   232,   232,
     237,   247,   257,   269,   272,   275,   276,   279,   280,   281,
     282,   283,   293,   296,   297,   300,   301,   302,   303,   304,
     305,   306,   309,   310,   313,   314,   315,   316,   317,   318,
     319,   320,   323,   326,   327,   330,   332,   334,   336,   338,
     340,   342,   344,   346,   348,   350,   352,   354,   356,   358,
     360,   362,   364,   366,   368,   372,   376,   377,   380,   389,
     389,   400,   411,   414,   415,   418,   419,   422,   425,   426,
     429,   434,   437,   438,   441,   446,   449,   450,   453,   456,
     459,   460,   463,   469,   472,   473,   476,   481,   489,   490,
     536,   548,   553
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "LB", "RB", "LP", "RP", "MENUS", "MENU",
  "BUTTON", "DEFAULT_FUNCTION", "PLUS", "MINUS", "ALL", "OR", "CURSORS",
  "ICONS", "COLOR", "SAVECOLOR", "MONOCHROME", "FUNCTION",
  "WINDOW_FUNCTION", "MAKE_TITLE", "GRAYSCALE", "NO_TITLE", "AUTO_RAISE",
  "META", "SHIFT", "LOCK", "CONTROL", "WINDOW", "TITLE", "ICON", "ROOT",
  "FRAME", "COLON", "EQUALS", "START_ICONIFIED", "MOVE", "RESIZE", "WAIT",
  "SELECT", "KILL", "LEFT_TITLEBUTTON", "RIGHT_TITLEBUTTON", "NUMBER",
  "KEYWORD", "NKEYWORD", "CKEYWORD", "CLKEYWORD", "FKEYWORD", "FSKEYWORD",
  "SKEYWORD", "DKEYWORD", "JKEYWORD", "WINDOW_RING", "WARP_CURSOR",
  "ERRORTOKEN", "NO_STACKMODE", "STRING", "$accept", "twmrc", "stmts",
  "stmt", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9",
  "$@10", "$@11", "$@12", "$@13", "$@14", "noarg", "sarg", "narg", "full",
  "fullkey", "keys", "key", "contexts", "context", "contextkeys",
  "contextkey", "cursor_list", "cursor_entries", "cursor_entry",
  "color_list", "color_entries", "color_entry", "$@15", "save_color_list",
  "s_color_entries", "s_color_entry", "win_color_list",
  "win_color_entries", "win_color_entry", "win_list", "win_entries",
  "win_entry", "icon_list", "icon_entries", "icon_entry", "function",
  "function_entries", "function_entry", "menu", "menu_entries",
  "menu_entry", "action", "button", "string", "number", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314
};
# endif

#define YYPACT_NINF -87

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-87)))

#define YYTABLE_NINF -110

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -87,    11,    23,   -87,   -87,   -46,   -28,   -21,    17,   -87,
     -87,    19,   -87,   -46,   -21,   -87,   -87,    22,   -87,   -87,
     -46,   -46,   -87,   -28,   -46,   -87,    33,    34,   -87,   -87,
     -87,   -87,   -87,   -24,    15,    45,   -87,   -87,   -87,   -46,
     -87,   -87,   -87,    49,    50,   -87,   -87,    50,   -87,   -87,
      54,    50,    54,    54,    54,    36,    40,   -87,   -87,    54,
      54,    54,   -87,   -87,   -87,   -87,   -87,   -87,   -46,    74,
     -87,   110,   -87,   -87,   -87,   -87,     0,   -87,    77,   -87,
     -87,   -87,   -87,   -87,   -87,   -21,   -21,   -87,   -87,   -87,
     151,   155,    48,   -87,   -87,   -87,   -46,   -46,   -46,   -46,
     -46,   -46,   -46,   -46,   -46,   -46,   -87,    -3,    64,   -87,
     -87,   -87,   -87,   -87,   -87,    -1,   -87,   -87,   -87,   -28,
     -87,   -87,   -87,   -87,   -87,   -87,   -46,     2,   -46,   -46,
     -46,   -46,   -46,   -46,   -46,   -46,   -46,   -46,   -87,   -87,
     -46,   -87,   -46,   -46,   -87,    14,   -87,   -87,   -87,   -87,
      73,   126,    78,   -87,   -87,     4,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,    82,   -87,
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -21,
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -21,   -87,
     -87,   -87,   -46,   -87,    85,   -87,   -87,    74,    55,   -87,
     -87,   -87,   -46,     3,    83,   -87,   -87,   -46,   -21,   -87,
     -87
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     1,     5,     0,     0,     0,     0,    34,
      36,     0,    41,     0,     0,    22,    38,    21,    26,    24,
       0,     0,    50,     0,     0,    48,    47,    18,   141,     4,
       6,     7,     8,     0,     0,    30,   142,   140,   138,     0,
      43,    83,     9,     0,     0,   113,    40,     0,    32,    44,
       0,     0,     0,     0,     0,     0,     0,    52,    51,     0,
       0,     0,    55,    15,    13,    12,    55,    14,     0,     0,
     139,     0,   126,    35,   106,    37,     0,    42,     0,   122,
      23,    39,    20,    27,    25,     0,     0,    49,    46,    17,
       0,     0,     0,   134,    31,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    84,     0,     0,   112,
     116,   114,   115,   130,    33,     0,    10,    11,    62,    57,
      58,    59,    60,    63,    56,    72,     0,     0,   100,    92,
      88,    90,    86,    94,    96,    98,   102,   104,   125,   127,
       0,   105,     0,     0,   107,     0,   121,   123,   124,    61,
       0,     0,     0,   133,   135,     0,    99,    91,    87,    89,
      85,    93,    95,    97,   101,   103,   128,   111,   108,   129,
     131,   132,    70,    71,    65,    66,    67,    68,    69,     0,
      64,    79,    80,    74,    75,    76,    77,    78,     0,    73,
      81,    28,     0,   136,     0,    53,    54,     0,     0,   118,
     110,    29,     0,     0,     0,   117,   119,     0,     0,   120,
     137
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   -87,    43,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   -37,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -87,   140,   -87,   -87,   -87,   -87,   -87,   -87,   -87,
     -87,   -86,   -87,   -87,   -12,   -87,    -5,   -18
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    29,    61,    52,    50,    54,    53,   197,
      69,    78,    43,    44,    51,    47,    60,    59,    30,    31,
      32,    63,    67,    90,   124,   150,   180,   151,   189,    42,
      71,   106,    75,   108,   144,   194,    46,    76,   111,   200,
     203,   206,    80,   115,   147,    73,   107,   139,   114,   145,
     170,    94,   127,   154,    40,    33,    34,    37
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      35,   138,    49,   146,   109,    57,   153,   205,    48,   192,
      77,     3,    62,    28,    81,    55,    56,    36,   169,    58,
      41,    64,    45,    -2,     4,   -19,    38,    39,    65,    38,
      39,     5,     6,     7,    70,    28,   -45,   -16,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,   110,
      68,    66,    72,    74,    38,    39,    28,    79,    28,    28,
      19,    28,    28,    92,    38,    39,    20,    21,   141,    22,
      23,   112,    85,   116,   117,    24,    86,    93,    25,    26,
     113,    27,    28,   126,   191,  -109,   172,   173,   199,   208,
     202,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   149,   140,   174,   175,   176,   177,   178,   179,    91,
     148,   201,   142,   143,    95,     0,     0,     0,    96,    97,
       0,   152,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   171,     0,   166,     0,   167,   168,   181,
     182,    98,    99,   193,   100,     0,   190,     0,   101,   102,
     103,   104,   105,     0,     0,     0,   183,   184,   185,   186,
     187,   188,     0,     0,     0,   118,     0,   195,     0,   118,
       0,     0,     0,     0,     0,     0,   196,   119,   120,   121,
     122,   119,   120,   121,   122,    28,   123,   198,     0,     0,
     125,     0,    82,    83,    84,     0,   210,   204,   207,    87,
      88,    89,   209
};

static const yytype_int16 yycheck[] =
{
       5,     4,    14,     4,     4,    23,     4,     4,    13,     5,
      47,     0,    36,    59,    51,    20,    21,    45,     4,    24,
       3,    33,     3,     0,     1,     3,    50,    51,    33,    50,
      51,     8,     9,    10,    39,    59,     3,     3,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    49,
       5,    36,     3,     3,    50,    51,    59,     3,    59,    59,
      37,    59,    59,    68,    50,    51,    43,    44,     4,    46,
      47,    76,    36,    85,    86,    52,    36,     3,    55,    56,
       3,    58,    59,    35,     6,     3,    13,    14,     3,     6,
      35,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   119,   107,    30,    31,    32,    33,    34,    35,    66,
     115,   197,    48,    49,     4,    -1,    -1,    -1,     8,     9,
      -1,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   145,    -1,   140,    -1,   142,   143,    13,
      14,    31,    32,   155,    34,    -1,   151,    -1,    38,    39,
      40,    41,    42,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    14,    -1,   179,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   188,    26,    27,    28,
      29,    26,    27,    28,    29,    59,    35,   192,    -1,    -1,
      35,    -1,    52,    53,    54,    -1,   208,   202,   203,    59,
      60,    61,   207
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    61,    62,     0,     1,     8,     9,    10,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    37,
      43,    44,    46,    47,    52,    55,    56,    58,    59,    63,
      78,    79,    80,   115,   116,   116,    45,   117,    50,    51,
     114,     3,    89,    72,    73,     3,    96,    75,   116,   114,
      66,    74,    65,    68,    67,   116,   116,   117,   116,    77,
      76,    64,    36,    81,   114,   116,    36,    82,     5,    70,
     116,    90,     3,   105,     3,    92,    97,    92,    71,     3,
     102,    92,   102,   102,   102,    36,    36,   102,   102,   102,
      83,    83,   116,     3,   111,     4,     8,     9,    31,    32,
      34,    38,    39,    40,    41,    42,    91,   106,    93,     4,
      49,    98,   116,     3,   108,   103,   114,   114,    14,    26,
      27,    28,    29,    35,    84,    35,    35,   112,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,     4,   107,
     116,     4,    48,    49,    94,   109,     4,   104,   116,   117,
      85,    87,   116,     4,   113,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,     4,
     110,   114,    13,    14,    30,    31,    32,    33,    34,    35,
      86,    13,    14,    30,    31,    32,    33,    34,    35,    88,
     116,     6,     5,   114,    95,   114,   114,    69,   116,     3,
      99,   111,    35,   100,   116,     4,   101,   116,     6,   116,
     114
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    60,    61,    62,    62,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    64,    63,    63,    65,
      63,    63,    66,    63,    67,    63,    68,    63,    69,    63,
      70,    63,    71,    63,    72,    63,    73,    63,    74,    63,
      63,    75,    63,    63,    63,    76,    63,    63,    77,    63,
      78,    79,    80,    81,    82,    83,    83,    84,    84,    84,
      84,    84,    84,    85,    85,    86,    86,    86,    86,    86,
      86,    86,    87,    87,    88,    88,    88,    88,    88,    88,
      88,    88,    89,    90,    90,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    92,    93,    93,    94,    95,
      94,    94,    96,    97,    97,    98,    98,    99,   100,   100,
     101,   102,   103,   103,   104,   105,   106,   106,   107,   108,
     109,   109,   110,   111,   112,   112,   113,   113,   114,   114,
     115,   116,   117
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     2,
       4,     4,     2,     2,     2,     2,     0,     3,     1,     0,
       3,     1,     0,     3,     0,     3,     0,     3,     0,     9,
       0,     4,     0,     4,     0,     3,     0,     3,     0,     3,
       2,     0,     3,     2,     2,     0,     3,     1,     0,     3,
       1,     2,     2,     6,     6,     0,     2,     1,     1,     1,
       1,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     0,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     0,     2,     2,     0,
       4,     2,     3,     0,     2,     1,     1,     3,     0,     2,
       2,     3,     0,     2,     1,     3,     0,     2,     2,     3,
       0,     2,     1,     3,     0,     2,     2,     7,     1,     2,
       2,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:
#line 144 "gram.y" /* yacc.c:1646  */
    {}
#line 1533 "gram.c" /* yacc.c:1646  */
    break;

  case 10:
#line 145 "gram.y" /* yacc.c:1646  */
    {
					  GotTitleButton ((yyvsp[-2].ptr), (yyvsp[0].num), False);
					}
#line 1541 "gram.c" /* yacc.c:1646  */
    break;

  case 11:
#line 148 "gram.y" /* yacc.c:1646  */
    {
					  GotTitleButton ((yyvsp[-2].ptr), (yyvsp[0].num), True);
					}
#line 1549 "gram.c" /* yacc.c:1646  */
    break;

  case 12:
#line 151 "gram.y" /* yacc.c:1646  */
    { root = GetRoot((yyvsp[0].ptr), NULLSTR, NULLSTR);
					  Scr->Mouse[(yyvsp[-1].num)][C_ROOT][0].func = F_MENU;
					  Scr->Mouse[(yyvsp[-1].num)][C_ROOT][0].menu = root;
					}
#line 1558 "gram.c" /* yacc.c:1646  */
    break;

  case 13:
#line 155 "gram.y" /* yacc.c:1646  */
    { Scr->Mouse[(yyvsp[-1].num)][C_ROOT][0].func = (yyvsp[0].num);
					  if ((yyvsp[0].num) == F_MENU)
					  {
					    pull->prev = NULL;
					    Scr->Mouse[(yyvsp[-1].num)][C_ROOT][0].menu = pull;
					  }
					  else
					  {
					    root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					    Scr->Mouse[(yyvsp[-1].num)][C_ROOT][0].item =
						AddToMenu(root,"x",Action,
							  NULL,(yyvsp[0].num),NULLSTR,NULLSTR);
					  }
					  Action = "";
					  pull = NULL;
					}
#line 1579 "gram.c" /* yacc.c:1646  */
    break;

  case 14:
#line 171 "gram.y" /* yacc.c:1646  */
    { GotKey((yyvsp[-1].ptr), (yyvsp[0].num)); }
#line 1585 "gram.c" /* yacc.c:1646  */
    break;

  case 15:
#line 172 "gram.y" /* yacc.c:1646  */
    { GotButton((yyvsp[-1].num), (yyvsp[0].num)); }
#line 1591 "gram.c" /* yacc.c:1646  */
    break;

  case 16:
#line 173 "gram.y" /* yacc.c:1646  */
    { list = &Scr->NoStackModeL; }
#line 1597 "gram.c" /* yacc.c:1646  */
    break;

  case 18:
#line 175 "gram.y" /* yacc.c:1646  */
    { if (Scr->FirstTime)
						Scr->StackMode = FALSE; }
#line 1604 "gram.c" /* yacc.c:1646  */
    break;

  case 19:
#line 177 "gram.y" /* yacc.c:1646  */
    { list = &Scr->NoTitle; }
#line 1610 "gram.c" /* yacc.c:1646  */
    break;

  case 21:
#line 179 "gram.y" /* yacc.c:1646  */
    { if (Scr->FirstTime)
						Scr->NoTitlebar = TRUE; }
#line 1617 "gram.c" /* yacc.c:1646  */
    break;

  case 22:
#line 181 "gram.y" /* yacc.c:1646  */
    { list = &Scr->MakeTitle; }
#line 1623 "gram.c" /* yacc.c:1646  */
    break;

  case 24:
#line 183 "gram.y" /* yacc.c:1646  */
    { list = &Scr->StartIconified; }
#line 1629 "gram.c" /* yacc.c:1646  */
    break;

  case 26:
#line 185 "gram.y" /* yacc.c:1646  */
    { list = &Scr->AutoRaise; }
#line 1635 "gram.c" /* yacc.c:1646  */
    break;

  case 28:
#line 187 "gram.y" /* yacc.c:1646  */
    {
					root = GetRoot((yyvsp[-5].ptr), (yyvsp[-3].ptr), (yyvsp[-1].ptr)); }
#line 1642 "gram.c" /* yacc.c:1646  */
    break;

  case 29:
#line 189 "gram.y" /* yacc.c:1646  */
    { root->real_menu = TRUE;}
#line 1648 "gram.c" /* yacc.c:1646  */
    break;

  case 30:
#line 190 "gram.y" /* yacc.c:1646  */
    { root = GetRoot((yyvsp[0].ptr), NULLSTR, NULLSTR); }
#line 1654 "gram.c" /* yacc.c:1646  */
    break;

  case 31:
#line 191 "gram.y" /* yacc.c:1646  */
    { root->real_menu = TRUE; }
#line 1660 "gram.c" /* yacc.c:1646  */
    break;

  case 32:
#line 192 "gram.y" /* yacc.c:1646  */
    { root = GetRoot((yyvsp[0].ptr), NULLSTR, NULLSTR); }
#line 1666 "gram.c" /* yacc.c:1646  */
    break;

  case 34:
#line 194 "gram.y" /* yacc.c:1646  */
    { list = &Scr->IconNames; }
#line 1672 "gram.c" /* yacc.c:1646  */
    break;

  case 36:
#line 196 "gram.y" /* yacc.c:1646  */
    { color = COLOR; }
#line 1678 "gram.c" /* yacc.c:1646  */
    break;

  case 38:
#line 198 "gram.y" /* yacc.c:1646  */
    { color = GRAYSCALE; }
#line 1684 "gram.c" /* yacc.c:1646  */
    break;

  case 41:
#line 202 "gram.y" /* yacc.c:1646  */
    { color = MONOCHROME; }
#line 1690 "gram.c" /* yacc.c:1646  */
    break;

  case 43:
#line 204 "gram.y" /* yacc.c:1646  */
    { Scr->DefaultFunction.func = (yyvsp[0].num);
					  if ((yyvsp[0].num) == F_MENU)
					  {
					    pull->prev = NULL;
					    Scr->DefaultFunction.menu = pull;
					  }
					  else
					  {
					    root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					    Scr->DefaultFunction.item =
						AddToMenu(root,"x",Action,
							  NULL,(yyvsp[0].num), NULLSTR, NULLSTR);
					  }
					  Action = "";
					  pull = NULL;
					}
#line 1711 "gram.c" /* yacc.c:1646  */
    break;

  case 44:
#line 220 "gram.y" /* yacc.c:1646  */
    { Scr->WindowFunction.func = (yyvsp[0].num);
					   root = GetRoot(TWM_ROOT,NULLSTR,NULLSTR);
					   Scr->WindowFunction.item =
						AddToMenu(root,"x",Action,
							  NULL,(yyvsp[0].num), NULLSTR, NULLSTR);
					   Action = "";
					   pull = NULL;
					}
#line 1724 "gram.c" /* yacc.c:1646  */
    break;

  case 45:
#line 228 "gram.y" /* yacc.c:1646  */
    { list = &Scr->WarpCursorL; }
#line 1730 "gram.c" /* yacc.c:1646  */
    break;

  case 47:
#line 230 "gram.y" /* yacc.c:1646  */
    { if (Scr->FirstTime)
					    Scr->WarpCursor = TRUE; }
#line 1737 "gram.c" /* yacc.c:1646  */
    break;

  case 48:
#line 232 "gram.y" /* yacc.c:1646  */
    { list = &Scr->WindowRingL; }
#line 1743 "gram.c" /* yacc.c:1646  */
    break;

  case 50:
#line 237 "gram.y" /* yacc.c:1646  */
    { if (!do_single_keyword ((yyvsp[0].num))) {
					    twmrc_error_prefix();
					    fprintf (stderr,
					"unknown singleton keyword %d\n",
						     (yyvsp[0].num));
					    ParseError = 1;
					  }
					}
#line 1756 "gram.c" /* yacc.c:1646  */
    break;

  case 51:
#line 247 "gram.y" /* yacc.c:1646  */
    { if (!do_string_keyword ((yyvsp[-1].num), (yyvsp[0].ptr))) {
					    twmrc_error_prefix();
					    fprintf (stderr,
				"unknown string keyword %d (value \"%s\")\n",
						     (yyvsp[-1].num), (yyvsp[0].ptr));
					    ParseError = 1;
					  }
					}
#line 1769 "gram.c" /* yacc.c:1646  */
    break;

  case 52:
#line 257 "gram.y" /* yacc.c:1646  */
    { if (!do_number_keyword ((yyvsp[-1].num), (yyvsp[0].num))) {
					    twmrc_error_prefix();
					    fprintf (stderr,
				"unknown numeric keyword %d (value %d)\n",
						     (yyvsp[-1].num), (yyvsp[0].num));
					    ParseError = 1;
					  }
					}
#line 1782 "gram.c" /* yacc.c:1646  */
    break;

  case 53:
#line 269 "gram.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 1788 "gram.c" /* yacc.c:1646  */
    break;

  case 54:
#line 272 "gram.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 1794 "gram.c" /* yacc.c:1646  */
    break;

  case 57:
#line 279 "gram.y" /* yacc.c:1646  */
    { mods |= Mod1Mask; }
#line 1800 "gram.c" /* yacc.c:1646  */
    break;

  case 58:
#line 280 "gram.y" /* yacc.c:1646  */
    { mods |= ShiftMask; }
#line 1806 "gram.c" /* yacc.c:1646  */
    break;

  case 59:
#line 281 "gram.y" /* yacc.c:1646  */
    { mods |= LockMask; }
#line 1812 "gram.c" /* yacc.c:1646  */
    break;

  case 60:
#line 282 "gram.y" /* yacc.c:1646  */
    { mods |= ControlMask; }
#line 1818 "gram.c" /* yacc.c:1646  */
    break;

  case 61:
#line 283 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].num) < 1 || (yyvsp[0].num) > 5) {
					     twmrc_error_prefix();
					     fprintf (stderr,
				"bad modifier number (%d), must be 1-5\n",
						      (yyvsp[0].num));
					     ParseError = 1;
					  } else {
					     mods |= (Mod1Mask << ((yyvsp[0].num) - 1));
					  }
					}
#line 1833 "gram.c" /* yacc.c:1646  */
    break;

  case 62:
#line 293 "gram.y" /* yacc.c:1646  */
    { }
#line 1839 "gram.c" /* yacc.c:1646  */
    break;

  case 65:
#line 300 "gram.y" /* yacc.c:1646  */
    { cont |= C_WINDOW_BIT; }
#line 1845 "gram.c" /* yacc.c:1646  */
    break;

  case 66:
#line 301 "gram.y" /* yacc.c:1646  */
    { cont |= C_TITLE_BIT; }
#line 1851 "gram.c" /* yacc.c:1646  */
    break;

  case 67:
#line 302 "gram.y" /* yacc.c:1646  */
    { cont |= C_ICON_BIT; }
#line 1857 "gram.c" /* yacc.c:1646  */
    break;

  case 68:
#line 303 "gram.y" /* yacc.c:1646  */
    { cont |= C_ROOT_BIT; }
#line 1863 "gram.c" /* yacc.c:1646  */
    break;

  case 69:
#line 304 "gram.y" /* yacc.c:1646  */
    { cont |= C_FRAME_BIT; }
#line 1869 "gram.c" /* yacc.c:1646  */
    break;

  case 70:
#line 305 "gram.y" /* yacc.c:1646  */
    { cont |= C_ALL_BITS; }
#line 1875 "gram.c" /* yacc.c:1646  */
    break;

  case 71:
#line 306 "gram.y" /* yacc.c:1646  */
    {  }
#line 1881 "gram.c" /* yacc.c:1646  */
    break;

  case 74:
#line 313 "gram.y" /* yacc.c:1646  */
    { cont |= C_WINDOW_BIT; }
#line 1887 "gram.c" /* yacc.c:1646  */
    break;

  case 75:
#line 314 "gram.y" /* yacc.c:1646  */
    { cont |= C_TITLE_BIT; }
#line 1893 "gram.c" /* yacc.c:1646  */
    break;

  case 76:
#line 315 "gram.y" /* yacc.c:1646  */
    { cont |= C_ICON_BIT; }
#line 1899 "gram.c" /* yacc.c:1646  */
    break;

  case 77:
#line 316 "gram.y" /* yacc.c:1646  */
    { cont |= C_ROOT_BIT; }
#line 1905 "gram.c" /* yacc.c:1646  */
    break;

  case 78:
#line 317 "gram.y" /* yacc.c:1646  */
    { cont |= C_FRAME_BIT; }
#line 1911 "gram.c" /* yacc.c:1646  */
    break;

  case 79:
#line 318 "gram.y" /* yacc.c:1646  */
    { cont |= C_ALL_BITS; }
#line 1917 "gram.c" /* yacc.c:1646  */
    break;

  case 80:
#line 319 "gram.y" /* yacc.c:1646  */
    { }
#line 1923 "gram.c" /* yacc.c:1646  */
    break;

  case 81:
#line 320 "gram.y" /* yacc.c:1646  */
    { Name = (yyvsp[0].ptr); cont |= C_NAME_BIT; }
#line 1929 "gram.c" /* yacc.c:1646  */
    break;

  case 85:
#line 330 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->FrameCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 1936 "gram.c" /* yacc.c:1646  */
    break;

  case 86:
#line 332 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->FrameCursor, (yyvsp[0].ptr)); }
#line 1943 "gram.c" /* yacc.c:1646  */
    break;

  case 87:
#line 334 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->TitleCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 1950 "gram.c" /* yacc.c:1646  */
    break;

  case 88:
#line 336 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->TitleCursor, (yyvsp[0].ptr)); }
#line 1957 "gram.c" /* yacc.c:1646  */
    break;

  case 89:
#line 338 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->IconCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 1964 "gram.c" /* yacc.c:1646  */
    break;

  case 90:
#line 340 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->IconCursor, (yyvsp[0].ptr)); }
#line 1971 "gram.c" /* yacc.c:1646  */
    break;

  case 91:
#line 342 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->ButtonCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 1978 "gram.c" /* yacc.c:1646  */
    break;

  case 92:
#line 344 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->ButtonCursor, (yyvsp[0].ptr)); }
#line 1985 "gram.c" /* yacc.c:1646  */
    break;

  case 93:
#line 346 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->MoveCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 1992 "gram.c" /* yacc.c:1646  */
    break;

  case 94:
#line 348 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->MoveCursor, (yyvsp[0].ptr)); }
#line 1999 "gram.c" /* yacc.c:1646  */
    break;

  case 95:
#line 350 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->ResizeCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2006 "gram.c" /* yacc.c:1646  */
    break;

  case 96:
#line 352 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->ResizeCursor, (yyvsp[0].ptr)); }
#line 2013 "gram.c" /* yacc.c:1646  */
    break;

  case 97:
#line 354 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->WaitCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2020 "gram.c" /* yacc.c:1646  */
    break;

  case 98:
#line 356 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->WaitCursor, (yyvsp[0].ptr)); }
#line 2027 "gram.c" /* yacc.c:1646  */
    break;

  case 99:
#line 358 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->MenuCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2034 "gram.c" /* yacc.c:1646  */
    break;

  case 100:
#line 360 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->MenuCursor, (yyvsp[0].ptr)); }
#line 2041 "gram.c" /* yacc.c:1646  */
    break;

  case 101:
#line 362 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->SelectCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2048 "gram.c" /* yacc.c:1646  */
    break;

  case 102:
#line 364 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->SelectCursor, (yyvsp[0].ptr)); }
#line 2055 "gram.c" /* yacc.c:1646  */
    break;

  case 103:
#line 366 "gram.y" /* yacc.c:1646  */
    {
			NewBitmapCursor(&Scr->DestroyCursor, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2062 "gram.c" /* yacc.c:1646  */
    break;

  case 104:
#line 368 "gram.y" /* yacc.c:1646  */
    {
			NewFontCursor(&Scr->DestroyCursor, (yyvsp[0].ptr)); }
#line 2069 "gram.c" /* yacc.c:1646  */
    break;

  case 108:
#line 380 "gram.y" /* yacc.c:1646  */
    { if (!do_colorlist_keyword ((yyvsp[-1].num), color,
								     (yyvsp[0].ptr))) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled list color keyword %d (string \"%s\")\n",
						     (yyvsp[-1].num), (yyvsp[0].ptr));
					    ParseError = 1;
					  }
					}
#line 2083 "gram.c" /* yacc.c:1646  */
    break;

  case 109:
#line 389 "gram.y" /* yacc.c:1646  */
    { list = do_colorlist_keyword((yyvsp[-1].num), color,
								      (yyvsp[0].ptr));
					  if (!list) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled color list keyword %d (string \"%s\")\n",
						     (yyvsp[-1].num), (yyvsp[0].ptr));
					    ParseError = 1;
					  }
					}
#line 2098 "gram.c" /* yacc.c:1646  */
    break;

  case 110:
#line 399 "gram.y" /* yacc.c:1646  */
    { /* No action */; }
#line 2104 "gram.c" /* yacc.c:1646  */
    break;

  case 111:
#line 400 "gram.y" /* yacc.c:1646  */
    { if (!do_color_keyword ((yyvsp[-1].num), color,
								 (yyvsp[0].ptr))) {
					    twmrc_error_prefix();
					    fprintf (stderr,
			"unhandled color keyword %d (string \"%s\")\n",
						     (yyvsp[-1].num), (yyvsp[0].ptr));
					    ParseError = 1;
					  }
					}
#line 2118 "gram.c" /* yacc.c:1646  */
    break;

  case 115:
#line 418 "gram.y" /* yacc.c:1646  */
    { do_string_savecolor(color, (yyvsp[0].ptr)); }
#line 2124 "gram.c" /* yacc.c:1646  */
    break;

  case 116:
#line 419 "gram.y" /* yacc.c:1646  */
    { do_var_savecolor((yyvsp[0].num)); }
#line 2130 "gram.c" /* yacc.c:1646  */
    break;

  case 120:
#line 429 "gram.y" /* yacc.c:1646  */
    { if (Scr->FirstTime &&
					      color == Scr->Monochrome)
					    AddToList(list, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2138 "gram.c" /* yacc.c:1646  */
    break;

  case 124:
#line 441 "gram.y" /* yacc.c:1646  */
    { if (Scr->FirstTime)
					    AddToList(list, (yyvsp[0].ptr), 0);
					}
#line 2146 "gram.c" /* yacc.c:1646  */
    break;

  case 128:
#line 453 "gram.y" /* yacc.c:1646  */
    { if (Scr->FirstTime) AddToList(list, (yyvsp[-1].ptr), (yyvsp[0].ptr)); }
#line 2152 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 463 "gram.y" /* yacc.c:1646  */
    { AddToMenu(root, "", Action, NULL, (yyvsp[0].num),
						NULLSTR, NULLSTR);
					  Action = "";
					}
#line 2161 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 476 "gram.y" /* yacc.c:1646  */
    { AddToMenu(root, (yyvsp[-1].ptr), Action, pull, (yyvsp[0].num),
						NULLSTR, NULLSTR);
					  Action = "";
					  pull = NULL;
					}
#line 2171 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 481 "gram.y" /* yacc.c:1646  */
    {
					  AddToMenu(root, (yyvsp[-6].ptr), Action, pull, (yyvsp[0].num),
						(yyvsp[-4].ptr), (yyvsp[-2].ptr));
					  Action = "";
					  pull = NULL;
					}
#line 2182 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 489 "gram.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 2188 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 490 "gram.y" /* yacc.c:1646  */
    {
				(yyval.num) = (yyvsp[-1].num);
				Action = (yyvsp[0].ptr);
				switch ((yyvsp[-1].num)) {
				  case F_MENU:
				    pull = GetRoot ((yyvsp[0].ptr), NULLSTR,NULLSTR);
				    pull->prev = root;
				    break;
				  case F_WARPRING:
				    if (!CheckWarpRingArg (Action)) {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.warptoring argument \"%s\"\n",
						 Action);
					(yyval.num) = F_NOP;
				    }
				  case F_WARPTOSCREEN:
				    if (!CheckWarpScreenArg (Action)) {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.warptoscreen argument \"%s\"\n",
					         Action);
					(yyval.num) = F_NOP;
				    }
				    break;
				  case F_COLORMAP:
				    if (CheckColormapArg (Action)) {
					(yyval.num) = F_COLORMAP;
				    } else {
					twmrc_error_prefix();
					fprintf (stderr,
			"ignoring invalid f.colormap argument \"%s\"\n",
						 Action);
					(yyval.num) = F_NOP;
				    }
				    break;
				} /* end switch */
				   }
#line 2231 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 536 "gram.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num);
					  if ((yyvsp[0].num) == 0)
						yyerror("bad button 0");

					  if ((yyvsp[0].num) > MAX_BUTTONS)
					  {
						(yyval.num) = 0;
						yyerror("button number too large");
					  }
					}
#line 2246 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 548 "gram.y" /* yacc.c:1646  */
    { ptr = strdup((yyvsp[0].ptr));
					  RemoveDQuote(ptr);
					  (yyval.ptr) = ptr;
					}
#line 2255 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 553 "gram.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 2261 "gram.c" /* yacc.c:1646  */
    break;


#line 2265 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 556 "gram.y" /* yacc.c:1906  */

static void
yyerror(const char *s)
{
    twmrc_error_prefix();
    fprintf (stderr, "error in input file:  %s\n", s ? s : "");
    ParseError = 1;
}

static void
RemoveDQuote(char *str)
{
    register char *i, *o;
    register int n;
    register int count;

    for (i=str+1, o=str; *i && *i != '\"'; o++)
    {
	if (*i == '\\')
	{
	    switch (*++i)
	    {
	    case 'n':
		*o = '\n';
		i++;
		break;
	    case 'b':
		*o = '\b';
		i++;
		break;
	    case 'r':
		*o = '\r';
		i++;
		break;
	    case 't':
		*o = '\t';
		i++;
		break;
	    case 'f':
		*o = '\f';
		i++;
		break;
	    case '0':
		if (*++i == 'x')
		    goto hex;
		else
		    --i;
	    case '1': case '2': case '3':
	    case '4': case '5': case '6': case '7':
		n = 0;
		count = 0;
		while (*i >= '0' && *i <= '7' && count < 3)
		{
		    n = (n<<3) + (*i++ - '0');
		    count++;
		}
		*o = n;
		break;
	    hex:
	    case 'x':
		n = 0;
		count = 0;
		while (i++, count++ < 2)
		{
		    if (*i >= '0' && *i <= '9')
			n = (n<<4) + (*i - '0');
		    else if (*i >= 'a' && *i <= 'f')
			n = (n<<4) + (*i - 'a') + 10;
		    else if (*i >= 'A' && *i <= 'F')
			n = (n<<4) + (*i - 'A') + 10;
		    else
			break;
		}
		*o = n;
		break;
	    case '\n':
		i++;	/* punt */
		o--;	/* to account for o++ at end of loop */
		break;
	    case '\"':
	    case '\'':
	    case '\\':
	    default:
		*o = *i++;
		break;
	    }
	}
	else
	    *o = *i++;
    }
    *o = '\0';
}

static MenuRoot *GetRoot(const char *name, const char* fore, const char *back)
{
    MenuRoot *tmp;

    tmp = FindMenuRoot(name);
    if (tmp == NULL)
	tmp = NewMenuRoot(name);

    if (fore)
    {
	int save;

	save = Scr->FirstTime;
	Scr->FirstTime = TRUE;
	GetColor(COLOR, &tmp->hi_fore, fore);
	GetColor(COLOR, &tmp->hi_back, back);
	Scr->FirstTime = save;
    }

    return tmp;
}

static void GotButton(int butt, int func)
{
    int i;

    for (i = 0; i < NUM_CONTEXTS; i++)
    {
	if ((cont & (1 << i)) == 0)
	    continue;

	Scr->Mouse[butt][i][mods].func = func;
	if (func == F_MENU)
	{
	    pull->prev = NULL;
	    Scr->Mouse[butt][i][mods].menu = pull;
	}
	else
	{
	    root = GetRoot(TWM_ROOT, NULLSTR, NULLSTR);
	    Scr->Mouse[butt][i][mods].item = AddToMenu(root,"x",Action,
		    NULL, func, NULLSTR, NULLSTR);
	}
    }
    Action = "";
    pull = NULL;
    cont = 0;
    mods_used |= mods;
    mods = 0;
}

static void GotKey(char *key, int func)
{
    int i;

    for (i = 0; i < NUM_CONTEXTS; i++)
    {
	if ((cont & (1 << i)) == 0)
	  continue;
	if (!AddFuncKey(key, i, mods, func, Name, Action))
	  break;
    }

    Action = "";
    pull = NULL;
    cont = 0;
    mods_used |= mods;
    mods = 0;
}


static void GotTitleButton (char *bitmapname, int func, Bool rightside)
{
    if (!CreateTitleButton (bitmapname, func, Action, pull, rightside, True)) {
	twmrc_error_prefix();
	fprintf (stderr,
		 "unable to create %s titlebutton \"%s\"\n",
		 rightside ? "right" : "left", bitmapname);
    }
    Action = "";
    pull = NULL;
}

static Bool CheckWarpScreenArg (char *s)
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s,  WARPSCREEN_NEXT) == 0 ||
	strcmp (s,  WARPSCREEN_PREV) == 0 ||
	strcmp (s,  WARPSCREEN_BACK) == 0)
      return True;

    for (; *s && isascii(*s) && isdigit(*s); s++) ; /* SUPPRESS 530 */
    return (*s ? False : True);
}


static Bool CheckWarpRingArg (char *s)
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s,  WARPSCREEN_NEXT) == 0 ||
	strcmp (s,  WARPSCREEN_PREV) == 0)
      return True;

    return False;
}


static Bool CheckColormapArg (char *s)
{
    XmuCopyISOLatin1Lowered (s, s);

    if (strcmp (s, COLORMAP_NEXT) == 0 ||
	strcmp (s, COLORMAP_PREV) == 0 ||
	strcmp (s, COLORMAP_DEFAULT) == 0)
      return True;

    return False;
}


void
twmrc_error_prefix (void)
{
    fprintf (stderr, "%s:  line %d:  ", ProgramName, yylineno);
}
